class PagesController < ApplicationController
  include ApplicationHelper
  before_filter :get_item, :only => [:index_from_link, :show_from_link]
  # caches_page :index

  def index
    @item = Page.find_by_name('home')

    if @item
      impressionist(@item)
      render_page 
    else
      render :text => 'You need a home page'
    end
  end
  
  def show  
    #begin  
      @item = Item.first(:conditions => {:path => params[:page_name]})
      #binding.pry
      if @item && @item.is_published && (@item.enabled_for.nil? ? true : @item.enabled_for.include?(I18n.locale.to_s))
        impressionist(@item)
        case @item.class.to_s
          when 'Page'
            render_page unless save_from_no_lang_for_page
          when 'Link'
            redirect_to(@item[:url]) unless save_from_no_lang_for_page
        end
      else
        render :file => "#{Rails.root}/public/404.html", :status => :not_found
      end
     #rescue
     #  render :file => "#{Rails.root}/public/404.html", :status => :not_found
     #end
   end
   
   def index_from_link
      url = "/#{@item.path}"
      options = ''
      options << "#{options.blank? ? '?' : '&'}page_main=#{params[:page_main]}" unless params[:page_main].blank?
      options << "#{options.blank? ? '?' : '&'}category_id=#{params[:category_id]}" unless params[:category_id].blank?
      options << "#{options.blank? ? '?' : '&'}tag_id=#{params[:tag_id]}" unless params[:tag_id].blank?
      options << "#{options.blank? ? '?' : '&'}search_query=#{params[:search_query]}" unless params[:search_query].blank?
      options << "#{options.blank? ? '?' : '&'}name=#{params[:name]}" unless params[:name].blank?
      uri = URI::escape(url + options)
      #uri = URI::escape("#{url}?" + params.collect{|k,v| "#{k}=#{v}"}.join('&'))
      redirect_to(uri)unless save_from_no_lang_for_page
   end
   
   def show_from_link
      url = "/#{@item.path}"
      options = ''
      options << "#{options.blank? ? '?' : '&'}id=#{params[:id]}" unless params[:id].blank?
      options << "#{options.blank? ? '?' : '&'}category_id=#{params[:category_id]}" unless params[:category_id].blank?
      options << "#{options.blank? ? '?' : '&'}tag_id=#{params[:tag_id]}" unless params[:tag_id].blank?
      options << "#{options.blank? ? '?' : '&'}preview=#{params[:preview]}" unless params[:preview].blank?
      options << "#{options.blank? ? '?' : '&'}controller_action=#{params[:controller_action]}" unless params[:controller_action].blank?
      redirect_to(url + options) unless save_from_no_lang_for_page
   end
   
   def load_orbit_bar
     render :partial => 'layouts/orbit_bar', :locals => {:referer => request.referer}
   end
   
   protected
   
   def get_item
      module_app = ModuleApp.first(:conditions => {:key => params[:app_name]})
      if !params[:category_id].blank? && !params[:tag_id].blank?
        @item = Item.first(:conditions => {:module_app_id => module_app.id, :app_frontend_url => params[:app_action], :category => params[:category_id], :tag => params[:tag_id]})
        @item = Item.first(:conditions => {:module_app_id => module_app.id, :app_frontend_url => params[:app_action], :category => params[:category_id], :tag => ''}) unless @item
      elsif !params[:category_id].blank?
        @item = Item.where(module_app_id: module_app.id,app_frontend_url:params[:app_action],category: params[:category_id]).any_in(tag: [nil,'']).first
      elsif !params[:tag_id].blank?
        @item = Item.where(module_app_id: module_app.id,app_frontend_url:params[:app_action],tag: params[:tag_id]).any_in(category: [nil,'']).first
      end
      @item = Item.where(module_app_id: module_app.id,app_frontend_url:params[:app_action]).all_of("tag" => {"$in" => [nil,'']},"category" => { "$in" => [nil,'']}).first unless @item
      #TODO 需要做 error handler 處理沒有新增該模組頁面導致錯誤的可能性
   end
  
  protected
  def save_from_no_lang_for_page
       if @item.nil? or !@item.enabled_for_lang(I18n.locale.to_s)
          flash[:error] = t('sys.module_page_lang_not_support')
          redirect_to '/'
        return true
      else
        return false
      end
  end
end
